#!/usr/bin/perl

use Win32::ODBC;

# Uebernahme des Querystrings auf unterschiedliche Weise
# je nach Request Method 'GET' oder 'POST'

if($ENV{'REQUEST_METHOD'} eq 'GET') {
    $query_string = $ENV{'QUERY_STRING'}
}
else {
    read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
}

# Auspacken der Werte der Formularfelder

@paare = split(/&/, $query_string);
foreach $paar (@paare) {
    ($name, $wert) = split(/=/, $paar);
    $wert =~ tr/+/ /;
    $wert =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $feldinhalt{$name} = $wert;
}

# Ausgabe des Kopfes der Ergebnisseite

print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>Email-Adressen: Ergebnis der Suche nach \"$feldinhalt{name}\"</TITLE>\n";
print "</HEAD>\n";
print "<BODY bgcolor=\"ffffcc\">\n";
print "<H2>HBI Stuttgart - Email-Adressen: Ergebnis der Suche nach \"$feldinhalt{name}\"</H2>";

# Durchfuehrung der Abfrage und Ausgabe der Ergebnisse

$DSN="email";
if (!($db=new Win32::ODBC($DSN))) {
    print "Error connecting to $DSN\n";
    print "Error: " . Win32::ODBC::Error() . "\n";
}
else {
    $SqlStatement =
        "SELECT Name, Vorname, Email FROM Adressen WHERE Name LIKE \'" . $feldinhalt{name} . "%\'";
    print "Executing Query: $SqlStatement \n";
    if ($db->Sql($SqlStatement)) {
        print "... failed.\n";
        print "Error: " . $db->Error() . "\n";
    }
    else {
        print "... done<br><br><br>\n";
        while($db->FetchRow()) {
            %Data = $db->DataHash();
            print "<b> $Data{'Vorname'} $Data{'Name'} </b><A HREF = mailto:$Data{'Email'}> &lt;$Data{'Email'}></A> <br> \n";
        }
    }
    $db->Close();
}

# Ausgabe des Schlusses der Ergebnisseite

print "</BODY>\n";
print "</HTML>\n";